#include "dialogmaze.h"
#include "ui_dialogmaze.h"
#include <globalMaze.h>

DialogMaze::DialogMaze(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogMaze)
{
    ui->setupUi(this);

    for(i = 0; i < 8; i++)
        for(j = 0; j < 8; j++)
            this->labels[i][j] = new QLabel(this);

    this->mGridLayout = new QGridLayout(this);
    for(i = 0; i< 8; i++)
        for(j = 0; j < 8; j++)
        {
            auto innerLayout = new QVBoxLayout;
            mGridLayout->addLayout(innerLayout,i,j);
            mGridLayout->setSpacing(0);
            innerLayout->addWidget(this->labels[i][j]);
            this->labels[i][j]->setScaledContents(true);
            this->labels[i][j]->setFixedSize(70,70);
            this->labels[i][j]->setMargin(0);
            switch (maze[i][j])
            {
            case 0b0000:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0000.png"));
                break;
            case 0b0001:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0001.png"));
                break;
            case 0b0010:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0010.png"));
                break;
            case 0b1000:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1000.png"));
                break;
            case 0b1010:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1010.png"));
                break;
            case 0b1001:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1001.png"));
                break;
            case 0b0011:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0011.png"));
                break;
            case 0b1011:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1011.png"));
                break;
            case 0b0100:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0100.png"));
                break;
            case 0b0101:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0101.png"));
                break;
            case 0b0110:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0110.png"));
                break;
            case 0b1100:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1100.png"));
                break;
            case 0b1101:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1101.png"));
                break;
            case 0b0111:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b0111.png"));
                break;
            case 0b1110:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1110.png"));
                break;
            case 0b1111:
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1111.png"));
                break;
            }
            if(maze[i][j]&16)
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b1xxxx.png"));
            if(maze[i][j]&32)
                this->labels[i][j]->setPixmap(QPixmap(":/pictures/b10xxxx.png"));
        }
    for(i = 0; i < 8; i++)
        for(j = 0; j < 8; j++)
            this->nlabels[i][j] = new QLabel(labels[i][j]);
    window()->setFixedSize( window()->sizeHint() );
}
void DialogMaze::movePerson()
{
    for(i = 0; i < 8; i++)
        for(j = 0; j < 8; j++)
            this->nlabels[i][j]->clear();
    this->nlabels[row][col]->setScaledContents(true);
    this->nlabels[row][col]->setGeometry(10,10,50,50);
    switch(rot)
    {
     case 0:
        this->nlabels[row][col]->setPixmap(QPixmap(":/pictures/personaggioMod.png"));
        break;
    case 1:
    case -3:
        this->nlabels[row][col]->setPixmap(QPixmap(":/pictures/personaggioRight.png"));
        break;
    case 2:
    case -2:
        this->nlabels[row][col]->setPixmap(QPixmap(":/pictures/personaggioDown.png"));
        break;
    case 3:
    case -1:
        this->nlabels[row][col]->setPixmap(QPixmap(":/pictures/personaggioLeft.png"));
        break;
    }
}

DialogMaze::~DialogMaze()
{
    delete ui;
}
